=== biosig4c++/DESCRIPTION ===
Name: BioSig
Version: 2.5.0
Date: 2022-12-27
Author: Alois Schloegl <alois.schloegl@gmail.com>
Maintainer: Alois Schloegl
Title: BioSig
Description: A software library for biomedical signal processing.
Depends: octave (> 4.0.0),
License: GPL version 3 or later
Url: http://biosig.sf.net
