=== biosig4c++/R/DESCRIPTION ===
Package: biosig
Version: 2.5.0
Date: 2020-08-22
Encoding: UTF-8
Title: Biomedical Signal Tools
Authors@R: person("Alois", "Schlögl", role = c("aut", "cre"),
                     email = "alois.schloegl@gmail.com", comment="https://orcid.org/0000-0002-5621-8100")
Author: Alois Schlögl [aut, cre]
Maintainer: Alois Schlögl <alois.schloegl@gmail.com>
Depends: R (>= 3.1.0)
Suggests: 
Description: Import filter for about 50 different biomedical signals data formats.
License: GPL (>= 3)
URL: https://biosig.sourceforge.io, http://pub.ist.ac.at/~schloegl
BugReports: https://sourceforge.net/projects/biosig/support
