=== debian/changelog ===
biosig (2.5.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version (all patches applied upstream)
  * Fix watch file
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 05 Jan 2023 08:15:48 +0100
