=== debian/control ===
Source: biosig
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>,
           Michael Hanke <michael.hanke@gmail.com>,
           Alois Schlögl <alois.schloegl@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               d-shlibs,
               gawk,
               python3-setuptools,
               python3-all-dev,
               python3-numpy,
               zlib1g-dev,
               libsuitesparse-dev,
               dh-octave,
               libdcmtk-dev,
               libtinyxml-dev,
               libb64-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/biosig
Vcs-Git: https://salsa.debian.org/med-team/biosig.git
Homepage: https://biosig.sourceforge.io/
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-python

Package: libbiosig3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: I/O library for biomedical data - dynamic library
 BioSig is a library for accessing files in several biomedical data formats
 (including EDF, BDF, GDF, BrainVision, BCI2000, CFWB, HL7aECG,
 SCP_ECG (EN1064), MFER, ACQ, CNT(Neuroscan), DEMG, EGI, EEG1100,
 FAMOS, SigmaPLpro, TMS32).  The complete list of supported file
 formats is available at http://pub.ist.ac.at/~schloegl/biosig/TESTED .
 .
 This package provides dynamic library.

Package: libbiosig-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libbiosig3 (= ${binary:Version}),
         ${devlibs:Depends},
         ${misc:Depends}
Description: I/O library for biomedical data - development files
 BioSig is a library for accessing files in several biomedical data formats
 (including EDF, BDF, GDF, BrainVision, BCI2000, CFWB, HL7aECG,
 SCP_ECG (EN1064), MFER, ACQ, CNT(Neuroscan), DEMG, EGI, EEG1100,
 FAMOS, SigmaPLpro, TMS32).  The complete list of supported file
 formats is available at http://pub.ist.ac.at/~schloegl/biosig/TESTED .
 .
 This package provides header files and static library.

Package: biosig-tools
Architecture: any
Depends: libbiosig3 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: format conversion tools for biomedical data formats
 Based on BioSig library, this package provides command line
 tools, such as
 .
  - save2gdf: converter between different file formats, including but
        not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF,
        BDF, CWFB.
  - biosig2gdf: converts biosig data files into GDF, to simplify
        parsing and loading by scripting languages (e.g. loadgdf.{py,r})
  - rec2bin, bin2rec, heka2itx, save2aecg, save2scp: several converter
       tools based on save2gdf
  - biosig_fhir: packs biosignal data into HL7/FHIR binary template file.
  - physicalunits: converter for encoding and decoding of physical
       units according to ISO 11073-10101

Package: python3-biosig
Architecture: any
Multi-Arch: same
Section: python
Depends: libbiosig3 (= ${binary:Version}),
         ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
Description: Python3 bindings for BioSig library
 This package provides Python3 bindings for BioSig library.  Primary
 goal -- I/O interface to variety of biomedical file formats, including
 but not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF.

Package: octave-biosig
Architecture: any
Multi-Arch: same
Depends: libbiosig3 (= ${binary:Version}),
         ${octave:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Description: Octave bindings for BioSig library
 This package provides Octave bindings for BioSig library.  Primary
 goal -- I/O interface to variety of biomedical file formats, including
 but not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF.
