## biosig 2.6.0

=== biosig4c++/DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Name: BioSig
-Version: 2.5.0
-Date: 2022-12-27
+Version: 2.6.0
+Date: 2024-02-19
 Author: Alois Schloegl <alois.schloegl@gmail.com>
 Maintainer: Alois Schloegl
 Title: BioSig
