=== debian/changelog ===
biosig (2.6.0-1ubuntu1) noble; urgency=medium

  * debian/patches: drop use of deprecated numpy.distutils
    (LP: #2060746)

 -- Nick Rosbrook <enr0n@ubuntu.com>  Wed, 10 Apr 2024 11:10:06 -0400

biosig (2.6.0-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:43:37 +0000

biosig (2.6.0-1build1) noble; urgency=high

  * No change rebuild against libdcmtk17t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 16:31:07 +0100

biosig (2.6.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * No need to preserve config.h any more

 -- Andreas Tille <tille@debian.org>  Mon, 19 Feb 2024 09:24:07 +0100

biosig (2.5.2-2) unstable; urgency=medium

  * Team upload.
  * Fix clean target
    Closes: #1043666

 -- Andreas Tille <tille@debian.org>  Tue, 06 Feb 2024 10:54:19 +0100

biosig (2.5.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Cope with missing config.status which is called in clean target

 -- Andreas Tille <tille@debian.org>  Thu, 19 Oct 2023 12:17:53 +0200
